// PDF417Vc6TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PDF417Vc6Test.h"
#include "PDF417Vc6TestDlg.h"
#include "../PDF417EncodeLib.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPDF417Vc6TestDlg dialog

CPDF417Vc6TestDlg::CPDF417Vc6TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPDF417Vc6TestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPDF417Vc6TestDlg)
	m_nMargin = 10;
	m_strText = _T("http://www.aipsys.com");
	m_nColumns = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPDF417Vc6TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPDF417Vc6TestDlg)
	DDX_Control(pDX, IDC_LEVEL, m_Level);
	DDX_Control(pDX, IDC_FORECOLOR, m_ForeColor);
	DDX_Control(pDX, IDC_BACKCOLOR, m_BackColor);
	DDX_Text(pDX, IDC_MARGIN, m_nMargin);
	DDX_Text(pDX, IDC_TEXT, m_strText);
	DDX_Text(pDX, IDC_COLUMNS, m_nColumns);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPDF417Vc6TestDlg, CDialog)
	//{{AFX_MSG_MAP(CPDF417Vc6TestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDSAVE, OnSave)
	ON_BN_CLICKED(IDBUY, OnBuy)
	ON_BN_CLICKED(IDENCODE, OnEncode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPDF417Vc6TestDlg message handlers

BOOL CPDF417Vc6TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_BackColor.SetColor(RGB(255,255,255));
    m_ForeColor.SetColor(RGB(0,0,0));
	SetDropDownSize(m_Level, 5);
	m_Level.SetCurSel(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPDF417Vc6TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPDF417Vc6TestDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	dc.TextOut(100,150,"Trial version will replace some elements of input ing with '*' randomly");
	if (xImage.GetHeight() == 0) return;

    int y = (313 - xImage.GetHeight()) / 2;
    int x = (620 - xImage.GetWidth()) / 2;

	xImage.Draw(dc.GetSafeHdc(),x,y);
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPDF417Vc6TestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPDF417Vc6TestDlg::SetDropDownSize(CComboBox &box, UINT LinesToDisplay)
{
    ASSERT(IsWindow(box));	// Window must exist or SetWindowPos won't work

    CRect cbSize;			// current size of combo box
    int Height;				// new height for drop-down portion of combo box

    box.GetClientRect(cbSize);
    Height = box.GetItemHeight(-1);      // start with size of the edit-box portion
    Height += box.GetItemHeight(0) * LinesToDisplay;	// add height of lines of text

    // Note: The use of SM_CYEDGE assumes that we're using Windows '95
    // Now add on the height of the border of the edit box
    Height += GetSystemMetrics(SM_CYEDGE) * 2; // top & bottom edges

    // The height of the border of the drop-down box
    Height += GetSystemMetrics(SM_CYEDGE) * 2; // top & bottom edges

    // now set the size of the window
    box.SetWindowPos(NULL,            // not relative to any other windows
        0, 0,                         // TopLeft corner doesn't change
        cbSize.right, Height,         // existing width, new height
        SWP_NOMOVE | SWP_NOZORDER     // don't move box or change z-ordering.
        );
}

void CPDF417Vc6TestDlg::OnSave() 
{
	CFileDialog dlgFile(FALSE);
	if (dlgFile.DoModal() == IDOK)
	{
		CString sFile = dlgFile.GetFileName();
		int nPos = sFile.ReverseFind('.');
		CString sExt = sFile.Right(sFile.GetLength() - nPos);
		sExt.MakeUpper();
		if (sExt == ".GIF")
			xImage.Save(sFile,CXIMAGE_FORMAT_GIF);
		else if (sExt == ".PNG")
			xImage.Save(sFile,CXIMAGE_FORMAT_PNG);
		else if (sExt == ".BMP")
			xImage.Save(sFile,CXIMAGE_FORMAT_BMP);
		else			xImage.Save(sFile,CXIMAGE_FORMAT_BMP);

	}		
}

void CPDF417Vc6TestDlg::OnBuy() 
{
   ShellExecute(this->GetSafeHwnd(),"open","http://www.aipsys.com/order.htm",NULL,NULL,SW_SHOW);			
}

void CPDF417Vc6TestDlg::OnEncode() 
{
   	_PDF417CONTEXT tPDF417Ctx;
//	xImage.Clear();
    UpdateData();	
	
	_InitPDF417Context(&tPDF417Ctx);

	tPDF417Ctx.nErrorCorrectLevel = m_Level.GetCurSel()+1;

	tPDF417Ctx.nColumns = m_nColumns;
	tPDF417Ctx.nMargin = m_nMargin;
	tPDF417Ctx.clBackGround = m_BackColor.GetColor();
	tPDF417Ctx.clForeGround = m_ForeColor.GetColor();
	if (m_strText != "") memcpy(tPDF417Ctx.cData,m_strText.GetBuffer(0),m_strText.GetLength());

	HBITMAP hbmp =_PDF417Encode2Bitmap(&tPDF417Ctx);
 //   SaveBitmapToFile(hbmp , "c:\\1.bmp");
    xImage.CreateFromHBITMAP(hbmp);
	_FreePDF417Context();
	Invalidate();	
}
